window.Gleam.initSearch([{"doc":"gliua","title":"gliua","content":"# Gliua\n\nGliua is a library for running Uiua code from gleam \n\n## Installation\n\nAdd `gliua` to to your Gleam project.\n\n```sh\ngleam add gliua\n```\n\n## Usage\n\n```gleam\n  import gliua/builder\n  import gliua/runtime\n  import gliua/decode\n\n  let eval_result =\n    []\n    |&gt; builder.push_int(2)\n    |&gt; builder.push_int(1)\n    |&gt; builder.join()\n    |&gt; builder.run_str(&quot;⊟.&quot;)\n    |&gt; builder.evaluate()\n\n  let assert Ok(runtime) = eval_result\n\n  runtime.stack(runtime)\n    |&gt; decode.stack_1(decode.rows(decode.rows(decode.int)))\n  //Ok([[1, 2], [1, 2]])\n```\n\n## Targets\n\nGliua currently only targets Erlang","url":"index.html"},{"doc":"gliua","title":"gliua","content":"","url":"gliua.html"},{"doc":"gliua/character","title":"Character","content":"pub opaque type Character\n\n\nSynonyms:\ngliua/character.Character\ngliua/character Character","url":"gliua/character.html#Character"},{"doc":"gliua/character","title":"from_string","content":"pub fn from_string(string: String) -&gt; Result(Character, Nil)\n Creates a Character from a String. If the string is not a length of 1, \n `Error(Nil)` will be returned.\nSynonyms:\ngliua/character.from_string\ngliua/character from_string","url":"gliua/character.html#from_string"},{"doc":"gliua/character","title":"to_string","content":"pub fn to_string(character: Character) -&gt; String\n Converts a Character into a String.\nSynonyms:\ngliua/character.to_string\ngliua/character to_string","url":"gliua/character.html#to_string"},{"doc":"gliua/character","title":"gliua/character","content":"","url":"gliua/character.html"},{"doc":"gliua/value","title":"Value","content":"pub type Value\n A Uiua value.\n\nSynonyms:\ngliua/value.Value\ngliua/value Value","url":"gliua/value.html#Value"},{"doc":"gliua/value","title":"rows","content":"pub fn rows(value: Value) -&gt; List(Value)\n Returns a list of the rows of a `Value`.\nSynonyms:\ngliua/value.rows\ngliua/value rows","url":"gliua/value.html#rows"},{"doc":"gliua/value","title":"to_string","content":"pub fn to_string(value: Value) -&gt; String\n Returns the string representation of a `Value`.\nSynonyms:\ngliua/value.to_string\ngliua/value to_string","url":"gliua/value.html#to_string"},{"doc":"gliua/value","title":"gliua/value","content":"","url":"gliua/value.html"},{"doc":"gliua/runtime","title":"Runtime","content":"pub type Runtime\n A Uiua runtime\n\nSynonyms:\ngliua/runtime.Runtime\ngliua/runtime Runtime","url":"gliua/runtime.html#Runtime"},{"doc":"gliua/runtime","title":"stack","content":"pub fn stack(runtime: Runtime) -&gt; List(Value)\n Retrieves the stack from the provided runtime.\nSynonyms:\ngliua/runtime.stack\ngliua/runtime stack","url":"gliua/runtime.html#stack"},{"doc":"gliua/runtime","title":"gliua/runtime","content":"","url":"gliua/runtime.html"},{"doc":"gliua/builder","title":"abs","content":"pub fn abs(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.abs\ngliua/builder abs","url":"gliua/builder.html#abs"},{"doc":"gliua/builder","title":"add","content":"pub fn add(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.add\ngliua/builder add","url":"gliua/builder.html#add"},{"doc":"gliua/builder","title":"all","content":"pub fn all(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.all\ngliua/builder all","url":"gliua/builder.html#all"},{"doc":"gliua/builder","title":"assert_","content":"pub fn assert_(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.assert_\ngliua/builder assert_","url":"gliua/builder.html#assert_"},{"doc":"gliua/builder","title":"atan","content":"pub fn atan(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.atan\ngliua/builder atan","url":"gliua/builder.html#atan"},{"doc":"gliua/builder","title":"bits","content":"pub fn bits(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.bits\ngliua/builder bits","url":"gliua/builder.html#bits"},{"doc":"gliua/builder","title":"box","content":"pub fn box(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.box\ngliua/builder box","url":"gliua/builder.html#box"},{"doc":"gliua/builder","title":"ceil","content":"pub fn ceil(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.ceil\ngliua/builder ceil","url":"gliua/builder.html#ceil"},{"doc":"gliua/builder","title":"classify","content":"pub fn classify(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.classify\ngliua/builder classify","url":"gliua/builder.html#classify"},{"doc":"gliua/builder","title":"complex","content":"pub fn complex(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.complex\ngliua/builder complex","url":"gliua/builder.html#complex"},{"doc":"gliua/builder","title":"coordinate","content":"pub fn coordinate(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.coordinate\ngliua/builder coordinate","url":"gliua/builder.html#coordinate"},{"doc":"gliua/builder","title":"couple","content":"pub fn couple(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.couple\ngliua/builder couple","url":"gliua/builder.html#couple"},{"doc":"gliua/builder","title":"csv","content":"pub fn csv(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.csv\ngliua/builder csv","url":"gliua/builder.html#csv"},{"doc":"gliua/builder","title":"deal","content":"pub fn deal(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.deal\ngliua/builder deal","url":"gliua/builder.html#deal"},{"doc":"gliua/builder","title":"deduplicate","content":"pub fn deduplicate(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.deduplicate\ngliua/builder deduplicate","url":"gliua/builder.html#deduplicate"},{"doc":"gliua/builder","title":"deshape","content":"pub fn deshape(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.deshape\ngliua/builder deshape","url":"gliua/builder.html#deshape"},{"doc":"gliua/builder","title":"divide","content":"pub fn divide(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.divide\ngliua/builder divide","url":"gliua/builder.html#divide"},{"doc":"gliua/builder","title":"do","content":"pub fn do(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.do\ngliua/builder do","url":"gliua/builder.html#do"},{"doc":"gliua/builder","title":"drop","content":"pub fn drop(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.drop\ngliua/builder drop","url":"gliua/builder.html#drop"},{"doc":"gliua/builder","title":"dump","content":"pub fn dump(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.dump\ngliua/builder dump","url":"gliua/builder.html#dump"},{"doc":"gliua/builder","title":"duplicate","content":"pub fn duplicate(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.duplicate\ngliua/builder duplicate","url":"gliua/builder.html#duplicate"},{"doc":"gliua/builder","title":"each","content":"pub fn each(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.each\ngliua/builder each","url":"gliua/builder.html#each"},{"doc":"gliua/builder","title":"equal_to","content":"pub fn equal_to(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.equal_to\ngliua/builder equal_to","url":"gliua/builder.html#equal_to"},{"doc":"gliua/builder","title":"eta","content":"pub fn eta(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.eta\ngliua/builder eta","url":"gliua/builder.html#eta"},{"doc":"gliua/builder","title":"evaluate","content":"pub fn evaluate(\n  instructions: List(Instruction),\n) -&gt; Result(Runtime, String)\n Evaluates a list of instructions and return the resulting runtime or an error string as a `Result`.\nSynonyms:\ngliua/builder.evaluate\ngliua/builder evaluate","url":"gliua/builder.html#evaluate"},{"doc":"gliua/builder","title":"fall","content":"pub fn fall(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.fall\ngliua/builder fall","url":"gliua/builder.html#fall"},{"doc":"gliua/builder","title":"fill","content":"pub fn fill(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.fill\ngliua/builder fill","url":"gliua/builder.html#fill"},{"doc":"gliua/builder","title":"find","content":"pub fn find(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.find\ngliua/builder find","url":"gliua/builder.html#find"},{"doc":"gliua/builder","title":"first","content":"pub fn first(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.first\ngliua/builder first","url":"gliua/builder.html#first"},{"doc":"gliua/builder","title":"fix","content":"pub fn fix(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.fix\ngliua/builder fix","url":"gliua/builder.html#fix"},{"doc":"gliua/builder","title":"flip","content":"pub fn flip(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.flip\ngliua/builder flip","url":"gliua/builder.html#flip"},{"doc":"gliua/builder","title":"floor","content":"pub fn floor(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.floor\ngliua/builder floor","url":"gliua/builder.html#floor"},{"doc":"gliua/builder","title":"fold","content":"pub fn fold(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.fold\ngliua/builder fold","url":"gliua/builder.html#fold"},{"doc":"gliua/builder","title":"generate","content":"pub fn generate(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.generate\ngliua/builder generate","url":"gliua/builder.html#generate"},{"doc":"gliua/builder","title":"get","content":"pub fn get(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.get\ngliua/builder get","url":"gliua/builder.html#get"},{"doc":"gliua/builder","title":"greater_than","content":"pub fn greater_than(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.greater_than\ngliua/builder greater_than","url":"gliua/builder.html#greater_than"},{"doc":"gliua/builder","title":"greater_than_or_equal_to","content":"pub fn greater_than_or_equal_to(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.greater_than_or_equal_to\ngliua/builder greater_than_or_equal_to","url":"gliua/builder.html#greater_than_or_equal_to"},{"doc":"gliua/builder","title":"group","content":"pub fn group(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.group\ngliua/builder group","url":"gliua/builder.html#group"},{"doc":"gliua/builder","title":"has","content":"pub fn has(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.has\ngliua/builder has","url":"gliua/builder.html#has"},{"doc":"gliua/builder","title":"index_of","content":"pub fn index_of(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.index_of\ngliua/builder index_of","url":"gliua/builder.html#index_of"},{"doc":"gliua/builder","title":"infinity","content":"pub fn infinity(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.infinity\ngliua/builder infinity","url":"gliua/builder.html#infinity"},{"doc":"gliua/builder","title":"insert","content":"pub fn insert(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.insert\ngliua/builder insert","url":"gliua/builder.html#insert"},{"doc":"gliua/builder","title":"inventory","content":"pub fn inventory(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.inventory\ngliua/builder inventory","url":"gliua/builder.html#inventory"},{"doc":"gliua/builder","title":"join","content":"pub fn join(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.join\ngliua/builder join","url":"gliua/builder.html#join"},{"doc":"gliua/builder","title":"keep","content":"pub fn keep(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.keep\ngliua/builder keep","url":"gliua/builder.html#keep"},{"doc":"gliua/builder","title":"length","content":"pub fn length(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.length\ngliua/builder length","url":"gliua/builder.html#length"},{"doc":"gliua/builder","title":"less_than","content":"pub fn less_than(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.less_than\ngliua/builder less_than","url":"gliua/builder.html#less_than"},{"doc":"gliua/builder","title":"less_than_or_equal_to","content":"pub fn less_than_or_equal_to(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.less_than_or_equal_to\ngliua/builder less_than_or_equal_to","url":"gliua/builder.html#less_than_or_equal_to"},{"doc":"gliua/builder","title":"log","content":"pub fn log(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.log\ngliua/builder log","url":"gliua/builder.html#log"},{"doc":"gliua/builder","title":"map","content":"pub fn map(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.map\ngliua/builder map","url":"gliua/builder.html#map"},{"doc":"gliua/builder","title":"mask","content":"pub fn mask(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.mask\ngliua/builder mask","url":"gliua/builder.html#mask"},{"doc":"gliua/builder","title":"match","content":"pub fn match(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.match\ngliua/builder match","url":"gliua/builder.html#match"},{"doc":"gliua/builder","title":"max","content":"pub fn max(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.max\ngliua/builder max","url":"gliua/builder.html#max"},{"doc":"gliua/builder","title":"member","content":"pub fn member(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.member\ngliua/builder member","url":"gliua/builder.html#member"},{"doc":"gliua/builder","title":"memoize","content":"pub fn memoize(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.memoize\ngliua/builder memoize","url":"gliua/builder.html#memoize"},{"doc":"gliua/builder","title":"min","content":"pub fn min(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.min\ngliua/builder min","url":"gliua/builder.html#min"},{"doc":"gliua/builder","title":"modulo","content":"pub fn modulo(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.modulo\ngliua/builder modulo","url":"gliua/builder.html#modulo"},{"doc":"gliua/builder","title":"multiply","content":"pub fn multiply(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.multiply\ngliua/builder multiply","url":"gliua/builder.html#multiply"},{"doc":"gliua/builder","title":"negate","content":"pub fn negate(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.negate\ngliua/builder negate","url":"gliua/builder.html#negate"},{"doc":"gliua/builder","title":"not","content":"pub fn not(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.not\ngliua/builder not","url":"gliua/builder.html#not"},{"doc":"gliua/builder","title":"not_equal_to","content":"pub fn not_equal_to(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.not_equal_to\ngliua/builder not_equal_to","url":"gliua/builder.html#not_equal_to"},{"doc":"gliua/builder","title":"now","content":"pub fn now(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.now\ngliua/builder now","url":"gliua/builder.html#now"},{"doc":"gliua/builder","title":"over","content":"pub fn over(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.over\ngliua/builder over","url":"gliua/builder.html#over"},{"doc":"gliua/builder","title":"parse","content":"pub fn parse(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.parse\ngliua/builder parse","url":"gliua/builder.html#parse"},{"doc":"gliua/builder","title":"partition","content":"pub fn partition(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.partition\ngliua/builder partition","url":"gliua/builder.html#partition"},{"doc":"gliua/builder","title":"pi","content":"pub fn pi(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.pi\ngliua/builder pi","url":"gliua/builder.html#pi"},{"doc":"gliua/builder","title":"pool","content":"pub fn pool(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.pool\ngliua/builder pool","url":"gliua/builder.html#pool"},{"doc":"gliua/builder","title":"pop","content":"pub fn pop(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.pop\ngliua/builder pop","url":"gliua/builder.html#pop"},{"doc":"gliua/builder","title":"pow","content":"pub fn pow(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.pow\ngliua/builder pow","url":"gliua/builder.html#pow"},{"doc":"gliua/builder","title":"push_byte_array","content":"pub fn push_byte_array(\n  instructions: List(Instruction),\n  value: List(Int),\n) -&gt; List(Instruction)\n Adds an instruction to push a byte array to the stack.\nSynonyms:\ngliua/builder.push_byte_array\ngliua/builder push_byte_array","url":"gliua/builder.html#push_byte_array"},{"doc":"gliua/builder","title":"push_char","content":"pub fn push_char(\n  instructions: List(Instruction),\n  value: Character,\n) -&gt; List(Instruction)\n Adds an instruction to push a character to the stack.\nSynonyms:\ngliua/builder.push_char\ngliua/builder push_char","url":"gliua/builder.html#push_char"},{"doc":"gliua/builder","title":"push_complex","content":"pub fn push_complex(\n  instructions: List(Instruction),\n  real: Float,\n  imaginary: Float,\n) -&gt; List(Instruction)\n Adds an instruction to push a complex number to the stack.\nSynonyms:\ngliua/builder.push_complex\ngliua/builder push_complex","url":"gliua/builder.html#push_complex"},{"doc":"gliua/builder","title":"push_complex_list","content":"pub fn push_complex_list(\n  instructions: List(Instruction),\n  value: List(#(Float, Float)),\n) -&gt; List(Instruction)\n Adds an instruction to push a list of complex numbers to the stack.\nSynonyms:\ngliua/builder.push_complex_list\ngliua/builder push_complex_list","url":"gliua/builder.html#push_complex_list"},{"doc":"gliua/builder","title":"push_float","content":"pub fn push_float(\n  instructions: List(Instruction),\n  value: Float,\n) -&gt; List(Instruction)\n Adds an instruction to push a float to the stack.\nSynonyms:\ngliua/builder.push_float\ngliua/builder push_float","url":"gliua/builder.html#push_float"},{"doc":"gliua/builder","title":"push_float_list","content":"pub fn push_float_list(\n  instructions: List(Instruction),\n  value: List(Float),\n) -&gt; List(Instruction)\n Adds an instruction to push a list of floats to the stack.\nSynonyms:\ngliua/builder.push_float_list\ngliua/builder push_float_list","url":"gliua/builder.html#push_float_list"},{"doc":"gliua/builder","title":"push_int","content":"pub fn push_int(\n  instructions: List(Instruction),\n  value: Int,\n) -&gt; List(Instruction)\n Adds an instruction to push an integer to the stack.\nSynonyms:\ngliua/builder.push_int\ngliua/builder push_int","url":"gliua/builder.html#push_int"},{"doc":"gliua/builder","title":"push_int_list","content":"pub fn push_int_list(\n  instructions: List(Instruction),\n  value: List(Int),\n) -&gt; List(Instruction)\n Adds an instruction to push a list of integers to the stack.\nSynonyms:\ngliua/builder.push_int_list\ngliua/builder push_int_list","url":"gliua/builder.html#push_int_list"},{"doc":"gliua/builder","title":"push_string","content":"pub fn push_string(\n  instructions: List(Instruction),\n  value: String,\n) -&gt; List(Instruction)\n Adds an instruction to push a string to the stack.\nSynonyms:\ngliua/builder.push_string\ngliua/builder push_string","url":"gliua/builder.html#push_string"},{"doc":"gliua/builder","title":"push_value","content":"pub fn push_value(\n  instructions: List(Instruction),\n  value: Value,\n) -&gt; List(Instruction)\n Adds an instruction to push a uiua value to the stack.\nSynonyms:\ngliua/builder.push_value\ngliua/builder push_value","url":"gliua/builder.html#push_value"},{"doc":"gliua/builder","title":"random","content":"pub fn random(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.random\ngliua/builder random","url":"gliua/builder.html#random"},{"doc":"gliua/builder","title":"range","content":"pub fn range(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.range\ngliua/builder range","url":"gliua/builder.html#range"},{"doc":"gliua/builder","title":"recieve","content":"pub fn recieve(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.recieve\ngliua/builder recieve","url":"gliua/builder.html#recieve"},{"doc":"gliua/builder","title":"recurse","content":"pub fn recurse(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.recurse\ngliua/builder recurse","url":"gliua/builder.html#recurse"},{"doc":"gliua/builder","title":"reduce","content":"pub fn reduce(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.reduce\ngliua/builder reduce","url":"gliua/builder.html#reduce"},{"doc":"gliua/builder","title":"regex","content":"pub fn regex(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.regex\ngliua/builder regex","url":"gliua/builder.html#regex"},{"doc":"gliua/builder","title":"remove","content":"pub fn remove(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.remove\ngliua/builder remove","url":"gliua/builder.html#remove"},{"doc":"gliua/builder","title":"repeat","content":"pub fn repeat(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.repeat\ngliua/builder repeat","url":"gliua/builder.html#repeat"},{"doc":"gliua/builder","title":"representation","content":"pub fn representation(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.representation\ngliua/builder representation","url":"gliua/builder.html#representation"},{"doc":"gliua/builder","title":"rerank","content":"pub fn rerank(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.rerank\ngliua/builder rerank","url":"gliua/builder.html#rerank"},{"doc":"gliua/builder","title":"reshape","content":"pub fn reshape(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.reshape\ngliua/builder reshape","url":"gliua/builder.html#reshape"},{"doc":"gliua/builder","title":"reverse","content":"pub fn reverse(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.reverse\ngliua/builder reverse","url":"gliua/builder.html#reverse"},{"doc":"gliua/builder","title":"rise","content":"pub fn rise(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.rise\ngliua/builder rise","url":"gliua/builder.html#rise"},{"doc":"gliua/builder","title":"rotate","content":"pub fn rotate(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.rotate\ngliua/builder rotate","url":"gliua/builder.html#rotate"},{"doc":"gliua/builder","title":"round","content":"pub fn round(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.round\ngliua/builder round","url":"gliua/builder.html#round"},{"doc":"gliua/builder","title":"rows","content":"pub fn rows(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.rows\ngliua/builder rows","url":"gliua/builder.html#rows"},{"doc":"gliua/builder","title":"run_file","content":"pub fn run_file(\n  instructions instructions: List(Instruction),\n  path str: String,\n) -&gt; List(Instruction)\n Adds an instruction to run a uiua source file.\nSynonyms:\ngliua/builder.run_file\ngliua/builder run_file","url":"gliua/builder.html#run_file"},{"doc":"gliua/builder","title":"run_str","content":"pub fn run_str(\n  instructions: List(Instruction),\n  str: String,\n) -&gt; List(Instruction)\n add an instruction to run uiua source code\nSynonyms:\ngliua/builder.run_str\ngliua/builder run_str","url":"gliua/builder.html#run_str"},{"doc":"gliua/builder","title":"scan","content":"pub fn scan(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.scan\ngliua/builder scan","url":"gliua/builder.html#scan"},{"doc":"gliua/builder","title":"select","content":"pub fn select(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.select\ngliua/builder select","url":"gliua/builder.html#select"},{"doc":"gliua/builder","title":"send","content":"pub fn send(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.send\ngliua/builder send","url":"gliua/builder.html#send"},{"doc":"gliua/builder","title":"set_inverse","content":"pub fn set_inverse(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.set_inverse\ngliua/builder set_inverse","url":"gliua/builder.html#set_inverse"},{"doc":"gliua/builder","title":"set_under","content":"pub fn set_under(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.set_under\ngliua/builder set_under","url":"gliua/builder.html#set_under"},{"doc":"gliua/builder","title":"shape","content":"pub fn shape(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.shape\ngliua/builder shape","url":"gliua/builder.html#shape"},{"doc":"gliua/builder","title":"shapes","content":"pub fn shapes(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.shapes\ngliua/builder shapes","url":"gliua/builder.html#shapes"},{"doc":"gliua/builder","title":"sign","content":"pub fn sign(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.sign\ngliua/builder sign","url":"gliua/builder.html#sign"},{"doc":"gliua/builder","title":"sin","content":"pub fn sin(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.sin\ngliua/builder sin","url":"gliua/builder.html#sin"},{"doc":"gliua/builder","title":"spawn","content":"pub fn spawn(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.spawn\ngliua/builder spawn","url":"gliua/builder.html#spawn"},{"doc":"gliua/builder","title":"sqrt","content":"pub fn sqrt(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.sqrt\ngliua/builder sqrt","url":"gliua/builder.html#sqrt"},{"doc":"gliua/builder","title":"stack","content":"pub fn stack(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.stack\ngliua/builder stack","url":"gliua/builder.html#stack"},{"doc":"gliua/builder","title":"subtract","content":"pub fn subtract(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.subtract\ngliua/builder subtract","url":"gliua/builder.html#subtract"},{"doc":"gliua/builder","title":"table","content":"pub fn table(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.table\ngliua/builder table","url":"gliua/builder.html#table"},{"doc":"gliua/builder","title":"tag","content":"pub fn tag(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.tag\ngliua/builder tag","url":"gliua/builder.html#tag"},{"doc":"gliua/builder","title":"take","content":"pub fn take(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.take\ngliua/builder take","url":"gliua/builder.html#take"},{"doc":"gliua/builder","title":"tau","content":"pub fn tau(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.tau\ngliua/builder tau","url":"gliua/builder.html#tau"},{"doc":"gliua/builder","title":"this","content":"pub fn this(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.this\ngliua/builder this","url":"gliua/builder.html#this"},{"doc":"gliua/builder","title":"trace","content":"pub fn trace(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.trace\ngliua/builder trace","url":"gliua/builder.html#trace"},{"doc":"gliua/builder","title":"transpose","content":"pub fn transpose(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.transpose\ngliua/builder transpose","url":"gliua/builder.html#transpose"},{"doc":"gliua/builder","title":"try","content":"pub fn try(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.try\ngliua/builder try","url":"gliua/builder.html#try"},{"doc":"gliua/builder","title":"try_recieve","content":"pub fn try_recieve(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.try_recieve\ngliua/builder try_recieve","url":"gliua/builder.html#try_recieve"},{"doc":"gliua/builder","title":"type_","content":"pub fn type_(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.type_\ngliua/builder type_","url":"gliua/builder.html#type_"},{"doc":"gliua/builder","title":"types","content":"pub fn types(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.types\ngliua/builder types","url":"gliua/builder.html#types"},{"doc":"gliua/builder","title":"unique","content":"pub fn unique(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.unique\ngliua/builder unique","url":"gliua/builder.html#unique"},{"doc":"gliua/builder","title":"utf","content":"pub fn utf(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.utf\ngliua/builder utf","url":"gliua/builder.html#utf"},{"doc":"gliua/builder","title":"wait","content":"pub fn wait(instructions: List(Instruction)) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.wait\ngliua/builder wait","url":"gliua/builder.html#wait"},{"doc":"gliua/builder","title":"where","content":"pub fn where(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.where\ngliua/builder where","url":"gliua/builder.html#where"},{"doc":"gliua/builder","title":"windows","content":"pub fn windows(\n  instructions: List(Instruction),\n) -&gt; List(Instruction)\n\nSynonyms:\ngliua/builder.windows\ngliua/builder windows","url":"gliua/builder.html#windows"},{"doc":"gliua/builder","title":"gliua/builder","content":" Helper functions for building a list of instructions to be evaluated.\n \n Use `run_str` to add an instruction to run uiua source code.\n Use `run_file` to add an instruction to run a uiua source file.\n Use `evaluate` to evaluate a list of instructions.","url":"gliua/builder.html"},{"doc":"gliua/decode","title":"DecodeError","content":"pub type DecodeError {\n  DecodeError(expected: String, found: String)\n}\n\nDecodeError(expected: String, found: String)\n\n\nSynonyms:\ngliua/decode.DecodeError\ngliua/decode DecodeError","url":"gliua/decode.html#DecodeError"},{"doc":"gliua/decode","title":"DecodeErrors","content":"pub type DecodeErrors =\n  List(DecodeError)\n\n\nSynonyms:\ngliua/decode.DecodeErrors\ngliua/decode DecodeErrors","url":"gliua/decode.html#DecodeErrors"},{"doc":"gliua/decode","title":"Decoder","content":"pub type Decoder(t) =\n  fn(Value) -&gt; Result(t, DecodeErrors)\n\n\nSynonyms:\ngliua/decode.Decoder\ngliua/decode Decoder","url":"gliua/decode.html#Decoder"},{"doc":"gliua/decode","title":"char","content":"pub fn char(value: Value) -&gt; Result(Character, List(DecodeError))\n Checks to see if a `Value` is a character, and returns that character if it is.\nSynonyms:\ngliua/decode.char\ngliua/decode char","url":"gliua/decode.html#char"},{"doc":"gliua/decode","title":"complex","content":"pub fn complex(\n  value: Value,\n) -&gt; Result(#(Float, Float), List(DecodeError))\n Checks to see if a `Value` is a complex number, and returns a touple of `#(real, imaginary)` if it is.\nSynonyms:\ngliua/decode.complex\ngliua/decode complex","url":"gliua/decode.html#complex"},{"doc":"gliua/decode","title":"float","content":"pub fn float(value: Value) -&gt; Result(Float, List(DecodeError))\n Checks to see if a `Value` is a float, and returns that float if it is.\nSynonyms:\ngliua/decode.float\ngliua/decode float","url":"gliua/decode.html#float"},{"doc":"gliua/decode","title":"int","content":"pub fn int(value: Value) -&gt; Result(Int, List(DecodeError))\n Checks to see if a `Value` is an integer, and returns that integer if it is.\nSynonyms:\ngliua/decode.int\ngliua/decode int","url":"gliua/decode.html#int"},{"doc":"gliua/decode","title":"rows","content":"pub fn rows(\n  of decoder_type: fn(Value) -&gt; Result(a, List(DecodeError)),\n) -&gt; fn(Value) -&gt; Result(List(a), List(DecodeError))\n Returns a list of a particular type\nSynonyms:\ngliua/decode.rows\ngliua/decode rows","url":"gliua/decode.html#rows"},{"doc":"gliua/decode","title":"stack_1","content":"pub fn stack_1(\n  first decoder: fn(Value) -&gt; Result(a, List(DecodeError)),\n) -&gt; fn(List(Value)) -&gt; Result(a, List(DecodeError))\n Decodes the first value of a list of values\nSynonyms:\ngliua/decode.stack_1\ngliua/decode stack_1","url":"gliua/decode.html#stack_1"},{"doc":"gliua/decode","title":"stack_2","content":"pub fn stack_2(\n  first decoder1: fn(Value) -&gt; Result(a, List(DecodeError)),\n  second decoder2: fn(Value) -&gt; Result(b, List(DecodeError)),\n) -&gt; fn(List(Value)) -&gt; Result(#(a, b), List(DecodeError))\n Decodes the first 2 values of a list of values\nSynonyms:\ngliua/decode.stack_2\ngliua/decode stack_2","url":"gliua/decode.html#stack_2"},{"doc":"gliua/decode","title":"stack_3","content":"pub fn stack_3(\n  first decoder1: fn(Value) -&gt; Result(a, List(DecodeError)),\n  second decoder2: fn(Value) -&gt; Result(b, List(DecodeError)),\n  third decoder3: fn(Value) -&gt; Result(c, List(DecodeError)),\n) -&gt; fn(List(Value)) -&gt; Result(#(a, b, c), List(DecodeError))\n Decodes the first 3 values of a list of values\nSynonyms:\ngliua/decode.stack_3\ngliua/decode stack_3","url":"gliua/decode.html#stack_3"},{"doc":"gliua/decode","title":"string","content":"pub fn string(value: Value) -&gt; Result(String, List(DecodeError))\n Checks to see if a `Value` is a string, and returns that string if it is.\nSynonyms:\ngliua/decode.string\ngliua/decode string","url":"gliua/decode.html#string"},{"doc":"gliua/decode","title":"gliua/decode","content":" Helper functions for decoding Uiua values.","url":"gliua/decode.html"}]);